##// END OF EJS Templates
erreurs
vidal -
r720:4b2455eecc9a
parent child
Show More
@@ -1,919 +1,902
1 #!/bin/sh
1 #!/bin/sh
2 ########################################################################
2 ########################################################################
3 # rpi23-gen-image.sh 2015-2017
3 # rpi23-gen-image.sh 2015-2017
4 #
4 #
5 # Advanced Debian "stretch" and "buster" bootstrap script for Raspberry Pi
5 # Advanced Debian "stretch" and "buster" bootstrap script for Raspberry Pi
6 #
6 #
7 # This program is free software; you can redistribute it and/or
7 # This program is free software; you can redistribute it and/or
8 # modify it under the terms of the GNU General Public License
8 # modify it under the terms of the GNU General Public License
9 # as published by the Free Software Foundation; either version 2
9 # as published by the Free Software Foundation; either version 2
10 # of the License, or (at your option) any later version.
10 # of the License, or (at your option) any later version.
11 #
11 #
12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 #
13 #
14 # Big thanks for patches and enhancements by 20+ github contributors!
14 # Big thanks for patches and enhancements by 20+ github contributors!
15 ########################################################################
15 ########################################################################
16
16
17 # Are we running as root?
17 # Are we running as root?
18 if [ "$(id -u)" -ne "0" ] ; then
18 if [ "$(id -u)" -ne "0" ] ; then
19 echo "error: this script must be executed with root privileges!"
19 echo "error: this script must be executed with root privileges!"
20 exit 1
20 exit 1
21 fi
21 fi
22
22
23 # Check if ./functions.sh script exists
23 # Check if ./functions.sh script exists
24 if [ ! -r "./functions.sh" ] ; then
24 if [ ! -r "./functions.sh" ] ; then
25 echo "error: './functions.sh' required script not found!"
25 echo "error: './functions.sh' required script not found!"
26 exit 1
26 exit 1
27 fi
27 fi
28
28
29 # Load utility functions
29 # Load utility functions
30 . ./functions.sh
30 . ./functions.sh
31
31
32 # Load parameters from configuration template file
32 # Load parameters from configuration template file
33 if [ -n "$CONFIG_TEMPLATE" ] ; then
33 if [ -n "$CONFIG_TEMPLATE" ] ; then
34 use_template
34 use_template
35 fi
35 fi
36
36
37 # Introduce settings
37 # Introduce settings
38 set -e
38 set -e
39 echo -n -e "\n#\n# RPi 0/1/2/3/4 Bootstrap Settings\n#\n"
39 echo -n -e "\n#\n# RPi 0/1/2/3/4 Bootstrap Settings\n#\n"
40 set -x
40 set -x
41
41
42 # Raspberry Pi model configuration
42 # Raspberry Pi model configuration
43 RPI_MODEL=${RPI_MODEL:=2}
43 RPI_MODEL=${RPI_MODEL:=2}
44
44
45 # Debian release
45 # Debian release
46 RELEASE=${RELEASE:=buster}
46 RELEASE=${RELEASE:=buster}
47 if [ $RELEASE = "bullseye" ] ; then
47 if [ $RELEASE = "bullseye" ] ; then
48 RELEASE=testing
48 RELEASE=testing
49 fi
49 fi
50
50
51 # Kernel Branch
51 # Kernel Branch
52 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
52 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
53
53
54 # URLs
54 # URLs
55 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
55 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
56 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
56 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
57 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
57 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
58 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
58 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
59 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
59 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
60 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
60 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
61 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
61 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
62 NEXMON_URL=${NEXMON_URL:=https://github.com/seemoo-lab/nexmon.git}
62 NEXMON_URL=${NEXMON_URL:=https://github.com/seemoo-lab/nexmon.git}
63 SYSTEMDSWAP_URL=${SYSTEMDSWAP_URL:=https://github.com/Nefelim4ag/systemd-swap.git}
63 SYSTEMDSWAP_URL=${SYSTEMDSWAP_URL:=https://github.com/Nefelim4ag/systemd-swap.git}
64
64
65 # Kernel deb packages for 32bit kernel
65 # Kernel deb packages for 32bit kernel
66 RPI_32_KERNEL_URL=${RPI_32_KERNEL_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel_20180422-141901_armhf.deb}
66 RPI_32_KERNEL_URL=${RPI_32_KERNEL_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel_20180422-141901_armhf.deb}
67 RPI_32_KERNELHEADER_URL=${RPI_32_KERNELHEADER_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel-headers_20180422-141901_armhf.deb}
67 RPI_32_KERNELHEADER_URL=${RPI_32_KERNELHEADER_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel-headers_20180422-141901_armhf.deb}
68 # Kernel has KVM and zswap enabled - use if KERNEL_* parameters and precompiled kernel are used
68 # Kernel has KVM and zswap enabled - use if KERNEL_* parameters and precompiled kernel are used
69 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.19.80.20191022/bcmrpi3-kernel-bis-4.19.80.20191022.tar.xz}
69 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.19.80.20191022/bcmrpi3-kernel-bis-4.19.80.20191022.tar.xz}
70 # Default precompiled 64bit kernel
70 # Default precompiled 64bit kernel
71 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.19.80.20191022/bcmrpi3-kernel-4.19.80.20191022.tar.xz}
71 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.19.80.20191022/bcmrpi3-kernel-4.19.80.20191022.tar.xz}
72 # Sakaki BIS Kernel RPI4 - https://github.com/sakaki-/bcm2711-kernel-bis
72 # Sakaki BIS Kernel RPI4 - https://github.com/sakaki-/bcm2711-kernel-bis
73 RPI4_64_BIS_KERNEL_URL=${RPI4_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcm2711-kernel-bis/releases/download/4.19.59.20190724/bcm2711-kernel-bis-4.19.59.20190724.tar.xz}
73 RPI4_64_BIS_KERNEL_URL=${RPI4_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcm2711-kernel-bis/releases/download/4.19.59.20190724/bcm2711-kernel-bis-4.19.59.20190724.tar.xz}
74 # Default precompiled 64bit kernel - https://github.com/sakaki-/bcm2711-kernel
74 # Default precompiled 64bit kernel - https://github.com/sakaki-/bcm2711-kernel
75 RPI4_64_DEF_KERNEL_URL=${RPI4_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcm2711-kernel-bis/releases/download/4.19.59.20190724/bcm2711-kernel-bis-4.19.59.20190724.tar.xz}
75 RPI4_64_DEF_KERNEL_URL=${RPI4_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcm2711-kernel-bis/releases/download/4.19.59.20190724/bcm2711-kernel-bis-4.19.59.20190724.tar.xz}
76 # Generic
76 # Generic
77 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_DEF_KERNEL_URL}
77 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_DEF_KERNEL_URL}
78 RPI4_64_KERNEL_URL=${RPI4_64_KERNEL_URL:=$RPI4_64_DEF_KERNEL_URL}
78 RPI4_64_KERNEL_URL=${RPI4_64_KERNEL_URL:=$RPI4_64_DEF_KERNEL_URL}
79 # Kali kernel src - used if ENABLE_NEXMON=true (they patch the wlan kernel modul)
79 # Kali kernel src - used if ENABLE_NEXMON=true (they patch the wlan kernel modul)
80 KALI_KERNEL_URL=${KALI_KERNEL_URL:=https://github.com/Re4son/re4son-raspberrypi-linux.git}
80 KALI_KERNEL_URL=${KALI_KERNEL_URL:=https://github.com/Re4son/re4son-raspberrypi-linux.git}
81
81
82 # Build directories
82 # Build directories
83 WORKDIR=$(pwd)
83 WORKDIR=$(pwd)
84 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
84 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
85 BUILDDIR="${BASEDIR}/build"
85 BUILDDIR="${BASEDIR}/build"
86
86
87 # Chroot directories
87 # Chroot directories
88 R="${BUILDDIR}/chroot"
88 R="${BUILDDIR}/chroot"
89 ETC_DIR="${R}/etc"
89 ETC_DIR="${R}/etc"
90 LIB_DIR="${R}/lib"
90 LIB_DIR="${R}/lib"
91 BOOT_DIR="${R}/boot/firmware"
91 BOOT_DIR="${R}/boot/firmware"
92 KERNEL_DIR="${R}/usr/src/linux"
92 KERNEL_DIR="${R}/usr/src/linux"
93 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
93 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
94 BLUETOOTH_FIRMWARE_DIR="${ETC_DIR}/firmware/bt"
94 BLUETOOTH_FIRMWARE_DIR="${ETC_DIR}/firmware/bt"
95
95
96 # Firmware directory: Blank if download from github
96 # Firmware directory: Blank if download from github
97 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
97 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
98
98
99 # General settings
99 # General settings
100 SET_ARCH=${SET_ARCH:=32}
100 SET_ARCH=${SET_ARCH:=32}
101 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
101 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
102 PASSWORD=${PASSWORD:=raspberry}
102 PASSWORD=${PASSWORD:=raspberry}
103 USER_PASSWORD=${USER_PASSWORD:=raspberry}
103 USER_PASSWORD=${USER_PASSWORD:=raspberry}
104 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
104 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
105 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
105 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
106 EXPANDROOT=${EXPANDROOT:=true}
106 EXPANDROOT=${EXPANDROOT:=true}
107 ENABLE_DPHYSSWAP=${ENABLE_DPHYSSWAP:=true}
107 ENABLE_DPHYSSWAP=${ENABLE_DPHYSSWAP:=true}
108
108
109 # Keyboard settings
109 # Keyboard settings
110 XKB_MODEL=${XKB_MODEL:=""}
110 XKB_MODEL=${XKB_MODEL:=""}
111 XKB_LAYOUT=${XKB_LAYOUT:=""}
111 XKB_LAYOUT=${XKB_LAYOUT:=""}
112 XKB_VARIANT=${XKB_VARIANT:=""}
112 XKB_VARIANT=${XKB_VARIANT:=""}
113 XKB_OPTIONS=${XKB_OPTIONS:=""}
113 XKB_OPTIONS=${XKB_OPTIONS:=""}
114
114
115 # Network settings (DHCP)
115 # Network settings (DHCP)
116 ENABLE_DHCP=${ENABLE_DHCP:=true}
116 ENABLE_DHCP=${ENABLE_DHCP:=true}
117
117
118 # Network settings (static)
118 # Network settings (static)
119 NET_ADDRESS=${NET_ADDRESS:=""}
119 NET_ADDRESS=${NET_ADDRESS:=""}
120 NET_GATEWAY=${NET_GATEWAY:=""}
120 NET_GATEWAY=${NET_GATEWAY:=""}
121 NET_DNS_1=${NET_DNS_1:=""}
121 NET_DNS_1=${NET_DNS_1:=""}
122 NET_DNS_2=${NET_DNS_2:=""}
122 NET_DNS_2=${NET_DNS_2:=""}
123 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
123 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
124 NET_NTP_1=${NET_NTP_1:=""}
124 NET_NTP_1=${NET_NTP_1:=""}
125 NET_NTP_2=${NET_NTP_2:=""}
125 NET_NTP_2=${NET_NTP_2:=""}
126
126
127 # APT settings
127 # APT settings
128 APT_PROXY=${APT_PROXY:=""}
128 APT_PROXY=${APT_PROXY:=""}
129 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
129 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
130 KEEP_APT_PROXY=${KEEP_APT_PROXY:=false}
130 KEEP_APT_PROXY=${KEEP_APT_PROXY:=false}
131
131
132 # Feature settings
132 # Feature settings
133 ENABLE_PRINTK=${ENABLE_PRINTK:=false}
133 ENABLE_PRINTK=${ENABLE_PRINTK:=false}
134 ENABLE_BLUETOOTH=${ENABLE_BLUETOOTH:=false}
134 ENABLE_BLUETOOTH=${ENABLE_BLUETOOTH:=false}
135 ENABLE_MINIUART_OVERLAY=${ENABLE_MINIUART_OVERLAY:=false}
135 ENABLE_MINIUART_OVERLAY=${ENABLE_MINIUART_OVERLAY:=false}
136 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
136 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
137 ENABLE_I2C=${ENABLE_I2C:=false}
137 ENABLE_I2C=${ENABLE_I2C:=false}
138 ENABLE_SPI=${ENABLE_SPI:=false}
138 ENABLE_SPI=${ENABLE_SPI:=false}
139 ENABLE_IPV6=${ENABLE_IPV6:=true}
139 ENABLE_IPV6=${ENABLE_IPV6:=true}
140 ENABLE_SSHD=${ENABLE_SSHD:=true}
140 ENABLE_SSHD=${ENABLE_SSHD:=true}
141 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
141 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
142 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
142 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
143 ENABLE_SOUND=${ENABLE_SOUND:=true}
143 ENABLE_SOUND=${ENABLE_SOUND:=true}
144 ENABLE_DBUS=${ENABLE_DBUS:=true}
144 ENABLE_DBUS=${ENABLE_DBUS:=true}
145 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
145 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
146 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
146 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
147 ENABLE_XORG=${ENABLE_XORG:=false}
147 ENABLE_XORG=${ENABLE_XORG:=false}
148 ENABLE_WM=${ENABLE_WM:=""}
148 ENABLE_WM=${ENABLE_WM:=""}
149 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
149 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
150 ENABLE_USER=${ENABLE_USER:=true}
150 ENABLE_USER=${ENABLE_USER:=true}
151 USER_NAME=${USER_NAME:="pi"}
151 USER_NAME=${USER_NAME:="pi"}
152 ENABLE_ROOT=${ENABLE_ROOT:=false}
152 ENABLE_ROOT=${ENABLE_ROOT:=false}
153 ENABLE_QEMU=${ENABLE_QEMU:=false}
153 ENABLE_QEMU=${ENABLE_QEMU:=false}
154 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
154 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
155
155
156 # SSH settings
156 # SSH settings
157 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
157 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
158 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
158 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
159 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
159 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
160 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
160 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
161 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
161 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
162
162
163 # Advanced settings
163 # Advanced settings
164 ENABLE_SYSTEMDSWAP=${ENABLE_SYSTEMDSWAP:=false}
164 ENABLE_SYSTEMDSWAP=${ENABLE_SYSTEMDSWAP:=false}
165 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
165 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
166 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
166 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
167 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
167 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
168 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
168 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
169 ENABLE_USBBOOT=${ENABLE_USBBOOT=false}
169 ENABLE_USBBOOT=${ENABLE_USBBOOT=false}
170 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
170 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
171 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=false}
171 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=false}
172 ENABLE_NEXMON=${ENABLE_NEXMON:=false}
172 ENABLE_NEXMON=${ENABLE_NEXMON:=false}
173 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
173 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
174 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
174 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
175 NEXMONSRC_DIR=${NEXMONSRC_DIR:=""}
175 NEXMONSRC_DIR=${NEXMONSRC_DIR:=""}
176 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
176 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
177 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
177 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
178 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
178 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
179 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
179 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
180 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
180 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
181 ENABLE_SPLASH=${ENABLE_SPLASH:=true}
181 ENABLE_SPLASH=${ENABLE_SPLASH:=true}
182 ENABLE_LOGO=${ENABLE_LOGO:=true}
182 ENABLE_LOGO=${ENABLE_LOGO:=true}
183 ENABLE_SILENT_BOOT=${ENABLE_SILENT_BOOT=false}
183 ENABLE_SILENT_BOOT=${ENABLE_SILENT_BOOT=false}
184 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
184 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
185
185
186 # Kernel compilation settings
186 # Kernel compilation settings
187 BUILD_KERNEL=${BUILD_KERNEL:=true}
187 BUILD_KERNEL=${BUILD_KERNEL:=true}
188 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
188 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
189 KERNEL_THREADS=${KERNEL_THREADS:=1}
189 KERNEL_THREADS=${KERNEL_THREADS:=1}
190 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
190 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
191 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
191 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
192 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
192 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
193 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
193 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
194 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
194 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
195 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
195 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
196 KERNEL_VIRT=${KERNEL_VIRT:=false}
196 KERNEL_VIRT=${KERNEL_VIRT:=false}
197 KERNEL_BPF=${KERNEL_BPF:=false}
197 KERNEL_BPF=${KERNEL_BPF:=false}
198 KERNEL_DEFAULT_GOV=${KERNEL_DEFAULT_GOV:=ondemand}
198 KERNEL_DEFAULT_GOV=${KERNEL_DEFAULT_GOV:=ondemand}
199 KERNEL_SECURITY=${KERNEL_SECURITY:=false}
199 KERNEL_SECURITY=${KERNEL_SECURITY:=false}
200 KERNEL_NF=${KERNEL_NF:=false}
200 KERNEL_NF=${KERNEL_NF:=false}
201 KERNEL_DHKEY=${KERNEL_DHKEY:=true}
201 KERNEL_DHKEY=${KERNEL_DHKEY:=true}
202 KERNEL_BTRFS=${KERNEL_BTRFS:=false}
202 KERNEL_BTRFS=${KERNEL_BTRFS:=false}
203 KERNEL_NSPAN=${KERNEL_NSPAN:=false}
203 KERNEL_NSPAN=${KERNEL_NSPAN:=false}
204 KERNEL_POEHAT=${KERNEL_POEHAT:=false}
204 KERNEL_POEHAT=${KERNEL_POEHAT:=false}
205
205
206 # Kernel compilation from source directory settings
206 # Kernel compilation from source directory settings
207 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
207 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
208 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
208 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
209 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
209 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
210 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
210 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
211
211
212 # Reduce disk usage settings
212 # Reduce disk usage settings
213 REDUCE_APT=${REDUCE_APT:=true}
213 REDUCE_APT=${REDUCE_APT:=true}
214 REDUCE_DOC=${REDUCE_DOC:=true}
214 REDUCE_DOC=${REDUCE_DOC:=true}
215 REDUCE_MAN=${REDUCE_MAN:=true}
215 REDUCE_MAN=${REDUCE_MAN:=true}
216 REDUCE_VIM=${REDUCE_VIM:=false}
216 REDUCE_VIM=${REDUCE_VIM:=false}
217 REDUCE_BASH=${REDUCE_BASH:=false}
217 REDUCE_BASH=${REDUCE_BASH:=false}
218 REDUCE_HWDB=${REDUCE_HWDB:=true}
218 REDUCE_HWDB=${REDUCE_HWDB:=true}
219 REDUCE_SSHD=${REDUCE_SSHD:=true}
219 REDUCE_SSHD=${REDUCE_SSHD:=true}
220 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
220 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
221
221
222 # Encrypted filesystem settings
222 # Encrypted filesystem settings
223 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
223 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
224 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
224 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
225 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
225 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
226 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64"}
226 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64"}
227 CRYPTFS_HASH=${CRYPTFS_HASH:="sha512"}
227 CRYPTFS_HASH=${CRYPTFS_HASH:="sha512"}
228 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
228 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
229 #Dropbear-initramfs supports unlocking encrypted filesystem via SSH on bootup
229 #Dropbear-initramfs supports unlocking encrypted filesystem via SSH on bootup
230 CRYPTFS_DROPBEAR=${CRYPTFS_DROPBEAR:=false}
230 CRYPTFS_DROPBEAR=${CRYPTFS_DROPBEAR:=false}
231 #Provide your own Dropbear Public RSA-OpenSSH Key otherwise it will be generated
231 #Provide your own Dropbear Public RSA-OpenSSH Key otherwise it will be generated
232 CRYPTFS_DROPBEAR_PUBKEY=${CRYPTFS_DROPBEAR_PUBKEY:=""}
232 CRYPTFS_DROPBEAR_PUBKEY=${CRYPTFS_DROPBEAR_PUBKEY:=""}
233
233
234 # Chroot scripts directory
234 # Chroot scripts directory
235 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
235 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
236
236
237 # Packages required in the chroot build environment
237 # Packages required in the chroot build environment
238 APT_INCLUDES=${APT_INCLUDES:=""}
238 APT_INCLUDES=${APT_INCLUDES:=""}
239
239
240 APT_INCLUDES="${APT_INCLUDES},flex,bison,libssl-dev,apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
240 APT_INCLUDES="${APT_INCLUDES},flex,bison,libssl-dev,apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
241
241
242 # Packages to exclude from chroot build environment
242 # Packages to exclude from chroot build environment
243 APT_EXCLUDES=${APT_EXCLUDES:=""}
243 APT_EXCLUDES=${APT_EXCLUDES:=""}
244
244
245 # Packages required for bootstrapping
245 # Packages required for bootstrapping
246
246
247 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus bison flex libssl-dev sudo"
247 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus bison flex libssl-dev sudo"
248 MISSING_PACKAGES=""
248 MISSING_PACKAGES=""
249
249
250 # Packages installed for c/c++ build environment in chroot (keep empty)
250 # Packages installed for c/c++ build environment in chroot (keep empty)
251 COMPILER_PACKAGES=""
251 COMPILER_PACKAGES=""
252
252
253 # Check if apt-cacher-ng has port 3142 open and set APT_PROXY
253 # Check if apt-cacher-ng has port 3142 open and set APT_PROXY
254 APT_CACHER_RUNNING=$(lsof -i :3142 | cut -d ' ' -f3 | uniq | sed '/^\s*$/d')
254 APT_CACHER_RUNNING=$(lsof -i :3142 | cut -d ' ' -f3 | uniq | sed '/^\s*$/d')
255 if [ "${APT_CACHER_RUNNING}" = "apt-cacher-ng" ] ; then
255 if [ "${APT_CACHER_RUNNING}" = "apt-cacher-ng" ] ; then
256 APT_PROXY=http://127.0.0.1:3142/
256 APT_PROXY=http://127.0.0.1:3142/
257 fi
257 fi
258
258
259 # Setup architecture specific settings
259 # Setup architecture specific settings
260 if [ -n "$SET_ARCH" ] ; then
260 if [ -n "$SET_ARCH" ] ; then
261 # 64-bit configuration
261 # 64-bit configuration
262 if [ "$SET_ARCH" = 64 ] ; then
262 if [ "$SET_ARCH" = 64 ] ; then
263 # General 64-bit depended settings
263 # General 64-bit depended settings
264 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
264 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
265 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
265 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
266 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
266 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
267
267
268 # Raspberry Pi model specific settings
268 # Raspberry Pi model specific settings
269 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
269 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
270 if [ "$RPI_MODEL" != 4 ] ; then
270 if [ "$RPI_MODEL" != 4 ] ; then
271 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
271 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
272 else
272 else
273 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
273 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
274 fi
274 fi
275
275
276 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
276 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
277 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
277 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
278 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
278 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
279 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
279 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
280 else
280 else
281 echo "error: Only Raspberry PI 3, 3B+ and 4 support 64-bit"
281 echo "error: Only Raspberry PI 3, 3B+ and 4 support 64-bit"
282 exit 1
282 exit 1
283 fi
283 fi
284 fi
284 fi
285
285
286 # 32-bit configuration
286 # 32-bit configuration
287 if [ "$SET_ARCH" = 32 ] ; then
287 if [ "$SET_ARCH" = 32 ] ; then
288 # General 32-bit dependend settings
288 # General 32-bit dependend settings
289 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
289 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
290 KERNEL_ARCH=${KERNEL_ARCH:=arm}
290 KERNEL_ARCH=${KERNEL_ARCH:=arm}
291 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
291 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
292
292
293 # Raspberry Pi model specific settings
293 # Raspberry Pi model specific settings
294 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
294 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
295 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
295 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
296 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
296 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
297 RELEASE_ARCH=${RELEASE_ARCH:=armel}
297 RELEASE_ARCH=${RELEASE_ARCH:=armel}
298 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
298 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
299 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
299 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
300 fi
300 fi
301
301
302 # Raspberry Pi model specific settings
302 # Raspberry Pi model specific settings
303 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
303 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
304 if [ "$RPI_MODEL" != 4 ] ; then
304 if [ "$RPI_MODEL" != 4 ] ; then
305 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
305 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
306 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
306 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
307 else
307 else
308 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
308 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
309 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7l.img}
309 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7l.img}
310 fi
310 fi
311
311
312 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
312 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
313 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
313 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
314 <<<<<<< HEAD
315 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
316 =======
317 >>>>>>> af203dbe173e4e5ca755058b3284dc61375ca579
318
314
319 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
315 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
320 fi
316 fi
321 fi
317 fi
322 # SET_ARCH not set
318 # SET_ARCH not set
323 else
319 else
324 echo "error: Please set '32' or '64' as value for SET_ARCH"
320 echo "error: Please set '32' or '64' as value for SET_ARCH"
325 exit 1
321 exit 1
326 fi
322 fi
327 # Device specific configuration and U-Boot configuration
323 # Device specific configuration and U-Boot configuration
328 case "$RPI_MODEL" in
324 case "$RPI_MODEL" in
329 0)
325 0)
330 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
326 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
331 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
327 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
332 ;;
328 ;;
333 1)
329 1)
334 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
330 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
335 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
331 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
336 ;;
332 ;;
337 1P)
333 1P)
338 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
334 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
339 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
335 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
340 ;;
336 ;;
341 2)
337 2)
342 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
338 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
343 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
339 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
344 ;;
340 ;;
345 3)
341 3)
346 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
342 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
347 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
343 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
348 ;;
344 ;;
349 3P)
345 3P)
350 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
346 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
351 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
347 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
352 ;;
348 ;;
353 4)
349 4)
354 DTB_FILE=${DTB_FILE:=bcm2711-rpi-4-b.dtb}
350 DTB_FILE=${DTB_FILE:=bcm2711-rpi-4-b.dtb}
355 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_4_defconfig}
351 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_4_defconfig}
356 ;;
352 ;;
357 *)
353 *)
358 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
354 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
359 exit 1
355 exit 1
360 ;;
356 ;;
361 esac
357 esac
362
358
363 # Raspberry PI 0,3,3P with Bluetooth and Wifi onboard
359 # Raspberry PI 0,3,3P with Bluetooth and Wifi onboard
364 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
360 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
365 # Include bluetooth packages on supported boards
361 # Include bluetooth packages on supported boards
366 if [ "$ENABLE_BLUETOOTH" = true ] ; then
362 if [ "$ENABLE_BLUETOOTH" = true ] ; then
367 APT_INCLUDES="${APT_INCLUDES},bluetooth,bluez"
363 APT_INCLUDES="${APT_INCLUDES},bluetooth,bluez"
368 fi
364 fi
369 if [ "$ENABLE_WIRELESS" = true ] ; then
365 if [ "$ENABLE_WIRELESS" = true ] ; then
370 APT_INCLUDES="${APT_INCLUDES},wireless-tools,crda,wireless-regdb"
366 APT_INCLUDES="${APT_INCLUDES},wireless-tools,crda,wireless-regdb"
371 fi
367 fi
372 else # Raspberry PI 1,1P,2 without Wifi and bluetooth onboard
368 else # Raspberry PI 1,1P,2 without Wifi and bluetooth onboard
373 # Check if the internal wireless interface is not supported by the RPi model
369 # Check if the internal wireless interface is not supported by the RPi model
374 if [ "$ENABLE_WIRELESS" = true ] || [ "$ENABLE_BLUETOOTH" = true ]; then
370 if [ "$ENABLE_WIRELESS" = true ] || [ "$ENABLE_BLUETOOTH" = true ]; then
375 echo "error: The selected Raspberry Pi model has no integrated interface for wireless or bluetooth"
371 echo "error: The selected Raspberry Pi model has no integrated interface for wireless or bluetooth"
376 exit 1
372 exit 1
377 fi
373 fi
378 fi
374 fi
379
375
380 if [ "$BUILD_KERNEL" = false ] && [ "$ENABLE_NEXMON" = true ]; then
376 if [ "$BUILD_KERNEL" = false ] && [ "$ENABLE_NEXMON" = true ]; then
381 echo "error: You have to compile kernel sources, if you want to enable nexmon"
377 echo "error: You have to compile kernel sources, if you want to enable nexmon"
382 exit 1
378 exit 1
383 fi
379 fi
384
380
385 # Prepare date string for default image file name
381 # Prepare date string for default image file name
386 DATE="$(date +%Y-%m-%d)"
382 DATE="$(date +%Y-%m-%d)"
387 if [ -z "$KERNEL_BRANCH" ] ; then
383 if [ -z "$KERNEL_BRANCH" ] ; then
388 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
384 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
389 else
385 else
390 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
386 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
391 fi
387 fi
392
388
393 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
389 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
394 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
390 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
395 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
391 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
396 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
392 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
397 exit 1
393 exit 1
398 fi
394 fi
399 fi
395 fi
400
396
401 # Add cmake to compile videocore sources
397 # Add cmake to compile videocore sources
402 if [ "$ENABLE_VIDEOCORE" = true ] ; then
398 if [ "$ENABLE_VIDEOCORE" = true ] ; then
403 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
399 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
404 fi
400 fi
405
401
406 # Add deps for nexmon
402 # Add deps for nexmon
407 if [ "$ENABLE_NEXMON" = true ] ; then
403 if [ "$ENABLE_NEXMON" = true ] ; then
408 <<<<<<< HEAD
404
409 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libgmp3-dev gawk qpdf bison flex make autoconf automake build-essential libtool"
405 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libgmp3-dev gawk qpdf bison flex make autoconf automake build-essential libtool"
410 =======
411 >>>>>>> af203dbe173e4e5ca755058b3284dc61375ca579
412 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libgmp3-dev gawk qpdf make autoconf automake build-essential libtool"
413 fi
406 fi
414
407
415 # Add libncurses5 to enable kernel menuconfig
408 # Add libncurses5 to enable kernel menuconfig
416 if [ "$KERNEL_MENUCONFIG" = true ] ; then
409 if [ "$KERNEL_MENUCONFIG" = true ] ; then
417 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
410 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
418 fi
411 fi
419
412
420 # Add ccache compiler cache for (faster) kernel cross (re)compilation
413 # Add ccache compiler cache for (faster) kernel cross (re)compilation
421 if [ "$KERNEL_CCACHE" = true ] ; then
414 if [ "$KERNEL_CCACHE" = true ] ; then
422 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
415 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
423 fi
416 fi
424
417
425 # Add cryptsetup package to enable filesystem encryption
418 # Add cryptsetup package to enable filesystem encryption
426 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
419 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
427 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
420 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
428 <<<<<<< HEAD
421
429 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
430 =======
431 >>>>>>> af203dbe173e4e5ca755058b3284dc61375ca579
432 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup,cryptsetup-initramfs"
422 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup,cryptsetup-initramfs"
433
423
434 # If cryptfs,dropbear and initramfs are enabled include dropbear-initramfs package
424 # If cryptfs,dropbear and initramfs are enabled include dropbear-initramfs package
435 if [ "$CRYPTFS_DROPBEAR" = true ] && [ "$ENABLE_INITRAMFS" = true ]; then
425 if [ "$CRYPTFS_DROPBEAR" = true ] && [ "$ENABLE_INITRAMFS" = true ]; then
436 APT_INCLUDES="${APT_INCLUDES},dropbear-initramfs"
426 APT_INCLUDES="${APT_INCLUDES},dropbear-initramfs"
437 fi
427 fi
438
428
439 if [ -z "$CRYPTFS_PASSWORD" ] ; then
429 if [ -z "$CRYPTFS_PASSWORD" ] ; then
440 echo "error: no password defined (CRYPTFS_PASSWORD)!"
430 echo "error: no password defined (CRYPTFS_PASSWORD)!"
441 exit 1
431 exit 1
442 fi
432 fi
443 ENABLE_INITRAMFS=true
433 ENABLE_INITRAMFS=true
444 fi
434 fi
445
435
446 # Add initramfs generation tools
436 # Add initramfs generation tools
447 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
437 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
448 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
438 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
449 fi
439 fi
450
440
451 # Add device-tree-compiler required for building the U-Boot bootloader
441 # Add device-tree-compiler required for building the U-Boot bootloader
452 if [ "$ENABLE_UBOOT" = true ] ; then
442 if [ "$ENABLE_UBOOT" = true ] ; then
453 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex,bc"
443 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex,bc"
454 fi
444 fi
455
445
456 if [ "$ENABLE_USBBOOT" = true ] ; then
446 if [ "$ENABLE_USBBOOT" = true ] ; then
457 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 2 ]; then
447 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 2 ]; then
458 echo "error: Booting from USB alone is only supported by Raspberry Pi 3 and 3P"
448 echo "error: Booting from USB alone is only supported by Raspberry Pi 3 and 3P"
459 exit 1
449 exit 1
460 fi
450 fi
461 fi
451 fi
462
452
463 # Check if root SSH (v2) public key file exists
453 # Check if root SSH (v2) public key file exists
464 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
454 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
465 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
455 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
466 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
456 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
467 exit 1
457 exit 1
468 fi
458 fi
469 fi
459 fi
470
460
471 # Check if $USER_NAME SSH (v2) public key file exists
461 # Check if $USER_NAME SSH (v2) public key file exists
472 if [ -n "$SSH_USER_PUB_KEY" ] ; then
462 if [ -n "$SSH_USER_PUB_KEY" ] ; then
473 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
463 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
474 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
464 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
475 exit 1
465 exit 1
476 fi
466 fi
477 fi
467 fi
478
468
479 if [ "$ENABLE_NEXMON" = true ] && [ -n "$KERNEL_BRANCH" ] ; then
469 if [ "$ENABLE_NEXMON" = true ] && [ -n "$KERNEL_BRANCH" ] ; then
480 echo "error: Please unset KERNEL_BRANCH if using ENABLE_NEXMON"
470 echo "error: Please unset KERNEL_BRANCH if using ENABLE_NEXMON"
481 exit 1
471 exit 1
482 fi
472 fi
483
473
484 # Check if all required packages are installed on the build system
474 # Check if all required packages are installed on the build system
485 for package in $REQUIRED_PACKAGES ; do
475 for package in $REQUIRED_PACKAGES ; do
486 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
476 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
487 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
477 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
488 fi
478 fi
489 done
479 done
490
480
491 # If there are missing packages ask confirmation for install, or exit
481 # If there are missing packages ask confirmation for install, or exit
492 if [ -n "$MISSING_PACKAGES" ] ; then
482 if [ -n "$MISSING_PACKAGES" ] ; then
493 echo "the following packages needed by this script are not installed:"
483 echo "the following packages needed by this script are not installed:"
494 echo "$MISSING_PACKAGES"
484 echo "$MISSING_PACKAGES"
495
485
496 printf "\ndo you want to install the missing packages right now? [y/n] "
486 printf "\ndo you want to install the missing packages right now? [y/n] "
497 read -r confirm
487 read -r confirm
498 [ "$confirm" != "y" ] && exit 1
488 [ "$confirm" != "y" ] && exit 1
499
489
500 # Make sure all missing required packages are installed
490 # Make sure all missing required packages are installed
501 <<<<<<< HEAD
502 apt-get -qq -y install `echo "${MISSING_PACKAGES}" | sed "s/ //"`
503 =======
504 >>>>>>> af203dbe173e4e5ca755058b3284dc61375ca579
505 apt-get update && apt-get -qq -y install `echo "${MISSING_PACKAGES}" | sed "s/ //"`
491 apt-get update && apt-get -qq -y install `echo "${MISSING_PACKAGES}" | sed "s/ //"`
506 fi
492 fi
507
493
508 # Check if ./bootstrap.d directory exists
494 # Check if ./bootstrap.d directory exists
509 if [ ! -d "./bootstrap.d/" ] ; then
495 if [ ! -d "./bootstrap.d/" ] ; then
510 echo "error: './bootstrap.d' required directory not found!"
496 echo "error: './bootstrap.d' required directory not found!"
511 exit 1
497 exit 1
512 fi
498 fi
513
499
514 # Check if ./files directory exists
500 # Check if ./files directory exists
515 if [ ! -d "./files/" ] ; then
501 if [ ! -d "./files/" ] ; then
516 echo "error: './files' required directory not found!"
502 echo "error: './files' required directory not found!"
517 exit 1
503 exit 1
518 fi
504 fi
519
505
520 # Check if specified KERNELSRC_DIR directory exists
506 # Check if specified KERNELSRC_DIR directory exists
521 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
507 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
522 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
508 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
523 exit 1
509 exit 1
524 fi
510 fi
525
511
526 # Check if specified UBOOTSRC_DIR directory exists
512 # Check if specified UBOOTSRC_DIR directory exists
527 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
513 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
528 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
514 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
529 exit 1
515 exit 1
530 fi
516 fi
531
517
532 # Check if specified VIDEOCORESRC_DIR directory exists
518 # Check if specified VIDEOCORESRC_DIR directory exists
533 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
519 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
534 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
520 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
535 exit 1
521 exit 1
536 fi
522 fi
537
523
538 # Check if specified FBTURBOSRC_DIR directory exists
524 # Check if specified FBTURBOSRC_DIR directory exists
539 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
525 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
540 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
526 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
541 exit 1
527 exit 1
542 fi
528 fi
543
529
544 # Check if specified NEXMONSRC_DIR directory exists
530 # Check if specified NEXMONSRC_DIR directory exists
545 if [ -n "$NEXMONSRC_DIR" ] && [ ! -d "$NEXMONSRC_DIR" ] ; then
531 if [ -n "$NEXMONSRC_DIR" ] && [ ! -d "$NEXMONSRC_DIR" ] ; then
546 echo "error: '${NEXMONSRC_DIR}' specified directory not found (NEXMONSRC_DIR)!"
532 echo "error: '${NEXMONSRC_DIR}' specified directory not found (NEXMONSRC_DIR)!"
547 exit 1
533 exit 1
548 fi
534 fi
549
535
550 # Check if specified CHROOT_SCRIPTS directory exists
536 # Check if specified CHROOT_SCRIPTS directory exists
551 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
537 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
552 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
538 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
553 exit 1
539 exit 1
554 fi
540 fi
555
541
556 # Check if specified device mapping already exists (will be used by cryptsetup)
542 # Check if specified device mapping already exists (will be used by cryptsetup)
557 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
543 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
558 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
544 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
559 exit 1
545 exit 1
560 fi
546 fi
561
547
562 # Don't clobber an old build
548 # Don't clobber an old build
563 if [ -e "$BUILDDIR" ] ; then
549 if [ -e "$BUILDDIR" ] ; then
564 echo "error: directory ${BUILDDIR} already exists, not proceeding"
550 echo "error: directory ${BUILDDIR} already exists, not proceeding"
565 exit 1
551 exit 1
566 fi
552 fi
567
553
568 # Setup chroot directory
554 # Setup chroot directory
569 mkdir -p "${R}"
555 mkdir -p "${R}"
570
556
571 # Check if build directory has enough of free disk space >512MB
557 # Check if build directory has enough of free disk space >512MB
572 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
558 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
573 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
559 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
574 exit 1
560 exit 1
575 fi
561 fi
576
562
577 set -x
563 set -x
578
564
579 # Call "cleanup" function on various signals and errors
565 # Call "cleanup" function on various signals and errors
580 trap cleanup 0 1 2 3 6
566 trap cleanup 0 1 2 3 6
581
567
582 # Add required packages for the minbase installation
568 # Add required packages for the minbase installation
583 if [ "$ENABLE_MINBASE" = true ] ; then
569 if [ "$ENABLE_MINBASE" = true ] ; then
584 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
570 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
585 fi
571 fi
586
572
587 # Add parted package, required to get partprobe utility
573 # Add parted package, required to get partprobe utility
588 if [ "$EXPANDROOT" = true ] ; then
574 if [ "$EXPANDROOT" = true ] ; then
589 APT_INCLUDES="${APT_INCLUDES},parted"
575 APT_INCLUDES="${APT_INCLUDES},parted"
590 fi
576 fi
591
577
592 # Add dphys-swapfile package, required to enable swap
578 # Add dphys-swapfile package, required to enable swap
593 if [ "$ENABLE_DPHYSSWAP" = true ] ; then
579 if [ "$ENABLE_DPHYSSWAP" = true ] ; then
594 APT_INCLUDES="${APT_INCLUDES},dphys-swapfile"
580 APT_INCLUDES="${APT_INCLUDES},dphys-swapfile"
595 fi
581 fi
596
582
597 # Add dbus package, recommended if using systemd
583 # Add dbus package, recommended if using systemd
598 if [ "$ENABLE_DBUS" = true ] ; then
584 if [ "$ENABLE_DBUS" = true ] ; then
599 APT_INCLUDES="${APT_INCLUDES},dbus"
585 APT_INCLUDES="${APT_INCLUDES},dbus"
600 fi
586 fi
601
587
602 # Add iptables IPv4/IPv6 package
588 # Add iptables IPv4/IPv6 package
603 if [ "$ENABLE_IPTABLES" = true ] ; then
589 if [ "$ENABLE_IPTABLES" = true ] ; then
604 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
590 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
605 fi
591 fi
606 # Add apparmor for KERNEL_SECURITY
592 # Add apparmor for KERNEL_SECURITY
607 if [ "$KERNEL_SECURITY" = true ] ; then
593 if [ "$KERNEL_SECURITY" = true ] ; then
608 APT_INCLUDES="${APT_INCLUDES},apparmor,apparmor-utils,apparmor-profiles,apparmor-profiles-extra,libapparmor-perl"
594 APT_INCLUDES="${APT_INCLUDES},apparmor,apparmor-utils,apparmor-profiles,apparmor-profiles-extra,libapparmor-perl"
609 fi
595 fi
610
596
611 # Add openssh server package
597 # Add openssh server package
612 if [ "$ENABLE_SSHD" = true ] ; then
598 if [ "$ENABLE_SSHD" = true ] ; then
613 APT_INCLUDES="${APT_INCLUDES},openssh-server"
599 APT_INCLUDES="${APT_INCLUDES},openssh-server"
614 fi
600 fi
615
601
616 # Add alsa-utils package
602 # Add alsa-utils package
617 if [ "$ENABLE_SOUND" = true ] ; then
603 if [ "$ENABLE_SOUND" = true ] ; then
618 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
604 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
619 fi
605 fi
620
606
621 # Add rng-tools package
607 # Add rng-tools package
622 if [ "$ENABLE_HWRANDOM" = true ] ; then
608 if [ "$ENABLE_HWRANDOM" = true ] ; then
623 APT_INCLUDES="${APT_INCLUDES},rng-tools"
609 APT_INCLUDES="${APT_INCLUDES},rng-tools"
624 fi
610 fi
625
611
626 # Add fbturbo video driver
612 # Add fbturbo video driver
627 if [ "$ENABLE_FBTURBO" = true ] ; then
613 if [ "$ENABLE_FBTURBO" = true ] ; then
628 # Enable xorg package dependencies
614 # Enable xorg package dependencies
629 ENABLE_XORG=true
615 ENABLE_XORG=true
630 fi
616 fi
631
617
632 # Add user defined window manager package
618 # Add user defined window manager package
633 if [ -n "$ENABLE_WM" ] ; then
619 if [ -n "$ENABLE_WM" ] ; then
634 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
620 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
635
621
636 # Enable xorg package dependencies
622 # Enable xorg package dependencies
637 ENABLE_XORG=true
623 ENABLE_XORG=true
638 fi
624 fi
639
625
640 # Add xorg package
626 # Add xorg package
641 if [ "$ENABLE_XORG" = true ] ; then
627 if [ "$ENABLE_XORG" = true ] ; then
642 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
628 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
643 fi
629 fi
644
630
645 # Replace selected packages with smaller clones
631 # Replace selected packages with smaller clones
646 if [ "$ENABLE_REDUCE" = true ] ; then
632 if [ "$ENABLE_REDUCE" = true ] ; then
647 # Add levee package instead of vim-tiny
633 # Add levee package instead of vim-tiny
648 if [ "$REDUCE_VIM" = true ] ; then
634 if [ "$REDUCE_VIM" = true ] ; then
649 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
635 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
650 fi
636 fi
651
637
652 # Add dropbear package instead of openssh-server
638 # Add dropbear package instead of openssh-server
653 if [ "$REDUCE_SSHD" = true ] ; then
639 if [ "$REDUCE_SSHD" = true ] ; then
654 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
640 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
655 fi
641 fi
656 fi
642 fi
657
643
658 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
644 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
659 if [ "$ENABLE_SYSVINIT" = false ] ; then
645 if [ "$ENABLE_SYSVINIT" = false ] ; then
660 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
646 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
661 fi
647 fi
662
648
663 # Configure kernel sources if no KERNELSRC_DIR
649 # Configure kernel sources if no KERNELSRC_DIR
664 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
650 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
665 KERNELSRC_CONFIG=true
651 KERNELSRC_CONFIG=true
666 fi
652 fi
667
653
668 # Configure reduced kernel
654 # Configure reduced kernel
669 if [ "$KERNEL_REDUCE" = true ] ; then
655 if [ "$KERNEL_REDUCE" = true ] ; then
670 KERNELSRC_CONFIG=false
656 KERNELSRC_CONFIG=false
671 fi
657 fi
672
658
673 # Configure qemu compatible kernel
659 # Configure qemu compatible kernel
674 if [ "$ENABLE_QEMU" = true ] ; then
660 if [ "$ENABLE_QEMU" = true ] ; then
675 DTB_FILE=vexpress-v2p-ca15_a7.dtb
661 DTB_FILE=vexpress-v2p-ca15_a7.dtb
676 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
662 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
677 KERNEL_DEFCONFIG="vexpress_defconfig"
663 KERNEL_DEFCONFIG="vexpress_defconfig"
678 if [ "$KERNEL_MENUCONFIG" = false ] ; then
664 if [ "$KERNEL_MENUCONFIG" = false ] ; then
679 KERNEL_OLDDEFCONFIG=true
665 KERNEL_OLDDEFCONFIG=true
680 fi
666 fi
681 fi
667 fi
682
668
683 # Execute bootstrap scripts
669 # Execute bootstrap scripts
684 for SCRIPT in bootstrap.d/*.sh; do
670 for SCRIPT in bootstrap.d/*.sh; do
685 head -n 3 "$SCRIPT"
671 head -n 3 "$SCRIPT"
686 . "$SCRIPT"
672 . "$SCRIPT"
687 done
673 done
688
674
689 ## Execute custom bootstrap scripts
675 ## Execute custom bootstrap scripts
690 if [ -d "custom.d" ] ; then
676 if [ -d "custom.d" ] ; then
691 for SCRIPT in custom.d/*.sh; do
677 for SCRIPT in custom.d/*.sh; do
692 . "$SCRIPT"
678 . "$SCRIPT"
693 done
679 done
694 fi
680 fi
695
681
696 # Execute custom scripts inside the chroot
682 # Execute custom scripts inside the chroot
697 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
683 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
698 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
684 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
699 chroot_exec /bin/bash -x <<'EOF'
685 chroot_exec /bin/bash -x <<'EOF'
700 for SCRIPT in /chroot_scripts/* ; do
686 for SCRIPT in /chroot_scripts/* ; do
701 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
687 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
702 $SCRIPT
688 $SCRIPT
703 fi
689 fi
704 done
690 done
705 EOF
691 EOF
706 rm -rf "${R}/chroot_scripts"
692 rm -rf "${R}/chroot_scripts"
707 fi
693 fi
708
694
709 # Remove c/c++ build environment from the chroot
695 # Remove c/c++ build environment from the chroot
710 chroot_remove_cc
696 chroot_remove_cc
711
697
712 # Generate required machine-id
698 # Generate required machine-id
713 MACHINE_ID=$(dbus-uuidgen)
699 MACHINE_ID=$(dbus-uuidgen)
714 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
700 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
715 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
701 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
716
702
717 # APT Cleanup
703 # APT Cleanup
718 chroot_exec apt-get -y clean
704 chroot_exec apt-get -y clean
719 chroot_exec apt-get -y autoclean
705 chroot_exec apt-get -y autoclean
720 chroot_exec apt-get -y autoremove
706 chroot_exec apt-get -y autoremove
721
707
722 # Unmount mounted filesystems
708 # Unmount mounted filesystems
723 umount -l "${R}/proc"
709 umount -l "${R}/proc"
724 umount -l "${R}/sys"
710 umount -l "${R}/sys"
725
711
726 # Clean up directories
712 # Clean up directories
727 rm -rf "${R}/run/*"
713 rm -rf "${R}/run/*"
728 rm -rf "${R}/tmp/*"
714 rm -rf "${R}/tmp/*"
729
715
730 # Clean up APT proxy settings
716 # Clean up APT proxy settings
731 if [ "$KEEP_APT_PROXY" = false ] ; then
717 if [ "$KEEP_APT_PROXY" = false ] ; then
732 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
718 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
733 fi
719 fi
734
720
735 # Clean up files
721 # Clean up files
736 rm -f "${ETC_DIR}/ssh/ssh_host_*"
722 rm -f "${ETC_DIR}/ssh/ssh_host_*"
737 rm -f "${ETC_DIR}/dropbear/dropbear_*"
723 rm -f "${ETC_DIR}/dropbear/dropbear_*"
738 rm -f "${ETC_DIR}/apt/sources.list.save"
724 rm -f "${ETC_DIR}/apt/sources.list.save"
739 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
725 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
740 rm -f "${ETC_DIR}/*-"
726 rm -f "${ETC_DIR}/*-"
741 rm -f "${ETC_DIR}/resolv.conf"
727 rm -f "${ETC_DIR}/resolv.conf"
742 rm -f "${R}/root/.bash_history"
728 rm -f "${R}/root/.bash_history"
743 rm -f "${R}/var/lib/urandom/random-seed"
729 rm -f "${R}/var/lib/urandom/random-seed"
744 rm -f "${R}/initrd.img"
730 rm -f "${R}/initrd.img"
745 rm -f "${R}/vmlinuz"
731 rm -f "${R}/vmlinuz"
746 rm -f "${R}${QEMU_BINARY}"
732 rm -f "${R}${QEMU_BINARY}"
747
733
748 if [ "$ENABLE_QEMU" = true ] ; then
734 if [ "$ENABLE_QEMU" = true ] ; then
749 # Setup QEMU directory
735 # Setup QEMU directory
750 mkdir "${BASEDIR}/qemu"
736 mkdir "${BASEDIR}/qemu"
751
737
752 # Copy kernel image to QEMU directory
738 # Copy kernel image to QEMU directory
753 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
739 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
754
740
755 # Copy kernel config to QEMU directory
741 # Copy kernel config to QEMU directory
756 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
742 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
757
743
758 # Copy kernel dtbs to QEMU directory
744 # Copy kernel dtbs to QEMU directory
759 for dtb in "${BOOT_DIR}/"*.dtb ; do
745 for dtb in "${BOOT_DIR}/"*.dtb ; do
760 if [ -f "${dtb}" ] ; then
746 if [ -f "${dtb}" ] ; then
761 install_readonly "${dtb}" "${BASEDIR}/qemu/"
747 install_readonly "${dtb}" "${BASEDIR}/qemu/"
762 fi
748 fi
763 done
749 done
764
750
765 # Copy kernel overlays to QEMU directory
751 # Copy kernel overlays to QEMU directory
766 if [ -d "${BOOT_DIR}/overlays" ] ; then
752 if [ -d "${BOOT_DIR}/overlays" ] ; then
767 # Setup overlays dtbs directory
753 # Setup overlays dtbs directory
768 mkdir "${BASEDIR}/qemu/overlays"
754 mkdir "${BASEDIR}/qemu/overlays"
769
755
770 for dtb in "${BOOT_DIR}/overlays/"*.dtbo ; do
756 for dtb in "${BOOT_DIR}/overlays/"*.dtbo ; do
771 if [ -f "${dtb}" ] ; then
757 if [ -f "${dtb}" ] ; then
772 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
758 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
773 fi
759 fi
774 done
760 done
775 fi
761 fi
776
762
777 # Copy u-boot files to QEMU directory
763 # Copy u-boot files to QEMU directory
778 if [ "$ENABLE_UBOOT" = true ] ; then
764 if [ "$ENABLE_UBOOT" = true ] ; then
779 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
765 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
780 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
766 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
781 fi
767 fi
782 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
768 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
783 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
769 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
784 fi
770 fi
785 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
771 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
786 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
772 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
787 fi
773 fi
788 fi
774 fi
789
775
790 # Copy initramfs to QEMU directory
776 # Copy initramfs to QEMU directory
791 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
777 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
792 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
778 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
793 fi
779 fi
794 fi
780 fi
795
781
796 # Calculate size of the chroot directory in KB
782 # Calculate size of the chroot directory in KB
797 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
783 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
798
784
799 # Calculate the amount of needed 512 Byte sectors
785 # Calculate the amount of needed 512 Byte sectors
800 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
786 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
801 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
787 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
802 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
788 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
803
789
804 # The root partition is EXT4
790 # The root partition is EXT4
805 # This means more space than the actual used space of the chroot is used.
791 # This means more space than the actual used space of the chroot is used.
806 # As overhead for journaling and reserved blocks 35% are added.
792 # As overhead for journaling and reserved blocks 35% are added.
807 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
793 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
808
794
809 # Calculate required image size in 512 Byte sectors
795 # Calculate required image size in 512 Byte sectors
810 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
796 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
811
797
812 # Prepare image file
798 # Prepare image file
813 if [ "$ENABLE_SPLITFS" = true ] ; then
799 if [ "$ENABLE_SPLITFS" = true ] ; then
814 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
800 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
815 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
801 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
816 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
802 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
817 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
803 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
818
804
819 # Write firmware/boot partition tables
805 # Write firmware/boot partition tables
820 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
806 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
821 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
807 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
822 EOM
808 EOM
823
809
824 # Write root partition table
810 # Write root partition table
825 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
811 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
826 ${TABLE_SECTORS},${ROOT_SECTORS},83
812 ${TABLE_SECTORS},${ROOT_SECTORS},83
827 EOM
813 EOM
828
814
829 # Setup temporary loop devices
815 # Setup temporary loop devices
830 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
816 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
831 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
817 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
832 else # ENABLE_SPLITFS=false
818 else # ENABLE_SPLITFS=false
833 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
819 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
834 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
820 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
835
821
836 # Write partition table
822 # Write partition table
837 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
823 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
838 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
824 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
839 ${ROOT_OFFSET},${ROOT_SECTORS},83
825 ${ROOT_OFFSET},${ROOT_SECTORS},83
840 EOM
826 EOM
841
827
842 # Setup temporary loop devices
828 # Setup temporary loop devices
843 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
829 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
844 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
830 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
845 fi
831 fi
846
832
847 if [ "$ENABLE_CRYPTFS" = true ] ; then
833 if [ "$ENABLE_CRYPTFS" = true ] ; then
848 # Create dummy ext4 fs
834 # Create dummy ext4 fs
849 mkfs.ext4 "$ROOT_LOOP"
835 mkfs.ext4 "$ROOT_LOOP"
850
836
851 # Setup password keyfile
837 # Setup password keyfile
852 touch .password
838 touch .password
853 chmod 600 .password
839 chmod 600 .password
854 echo -n ${CRYPTFS_PASSWORD} > .password
840 echo -n ${CRYPTFS_PASSWORD} > .password
855
841
856 # Initialize encrypted partition
842 # Initialize encrypted partition
857 <<<<<<< HEAD
843
858 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
859 =======
860 >>>>>>> af203dbe173e4e5ca755058b3284dc61375ca579
861 cryptsetup --verbose --debug -q luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -h "${CRYPTFS_HASH}" -s "${CRYPTFS_XTSKEYSIZE}" .password
844 cryptsetup --verbose --debug -q luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -h "${CRYPTFS_HASH}" -s "${CRYPTFS_XTSKEYSIZE}" .password
862
845
863 # Open encrypted partition and setup mapping
846 # Open encrypted partition and setup mapping
864 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
847 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
865
848
866 # Secure delete password keyfile
849 # Secure delete password keyfile
867 shred -zu .password
850 shred -zu .password
868
851
869 # Update temporary loop device
852 # Update temporary loop device
870 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
853 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
871
854
872 # Wipe encrypted partition (encryption cipher is used for randomness)
855 # Wipe encrypted partition (encryption cipher is used for randomness)
873 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
856 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
874 fi
857 fi
875
858
876 # Build filesystems
859 # Build filesystems
877 mkfs.vfat "$FRMW_LOOP"
860 mkfs.vfat "$FRMW_LOOP"
878 mkfs.ext4 "$ROOT_LOOP"
861 mkfs.ext4 "$ROOT_LOOP"
879
862
880 # Mount the temporary loop devices
863 # Mount the temporary loop devices
881 mkdir -p "$BUILDDIR/mount"
864 mkdir -p "$BUILDDIR/mount"
882 mount "$ROOT_LOOP" "$BUILDDIR/mount"
865 mount "$ROOT_LOOP" "$BUILDDIR/mount"
883
866
884 mkdir -p "$BUILDDIR/mount/boot/firmware"
867 mkdir -p "$BUILDDIR/mount/boot/firmware"
885 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
868 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
886
869
887 # Copy all files from the chroot to the loop device mount point directory
870 # Copy all files from the chroot to the loop device mount point directory
888 rsync -a "${R}/" "$BUILDDIR/mount/"
871 rsync -a "${R}/" "$BUILDDIR/mount/"
889
872
890 # Unmount all temporary loop devices and mount points
873 # Unmount all temporary loop devices and mount points
891 cleanup
874 cleanup
892
875
893 # Create block map file(s) of image(s)
876 # Create block map file(s) of image(s)
894 if [ "$ENABLE_SPLITFS" = true ] ; then
877 if [ "$ENABLE_SPLITFS" = true ] ; then
895 # Create block map files for "bmaptool"
878 # Create block map files for "bmaptool"
896 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
879 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
897 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
880 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
898
881
899 # Image was successfully created
882 # Image was successfully created
900 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
883 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
901 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
884 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
902 else
885 else
903 # Create block map file for "bmaptool"
886 # Create block map file for "bmaptool"
904 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
887 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
905
888
906 # Image was successfully created
889 # Image was successfully created
907 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
890 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
908
891
909 # Create qemu qcow2 image
892 # Create qemu qcow2 image
910 if [ "$ENABLE_QEMU" = true ] ; then
893 if [ "$ENABLE_QEMU" = true ] ; then
911 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
894 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
912 QEMU_SIZE=16G
895 QEMU_SIZE=16G
913
896
914 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
897 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
915 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
898 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
916
899
917 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
900 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
918 fi
901 fi
919 fi
902 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant